{"swagger":"2.0","info":{"version":"1","title":"Elastic Cloud Enterprise API","termsOfService":"","x-doc-license":{"name":"Attribution-NonCommercial-NoDerivatives 4.0 International","url":"https://creativecommons.org/licenses/by-nc-nd/4.0/"},"x-feedbackLink":{"label":"Feedback","url":"https://github.com/elastic/docs-content/issues/new?assignees=&labels=feedback%2Ccommunity&projects=&template=api-feedback.yaml&title=%5BFeedback%5D%3A+"},"description":"This RESTful API enables you to create and manage both your Elastic Stack deployments and the ECE platform.\n\nNOTE: This documentation applies to the Elastic Cloud Enterprise API only.\nIf you are using Elasticsearch Service, use the [Elastic Cloud API](https://www.elastic.co/docs/api/doc/cloud).\n\nThis API supports both key-based and token-based authentication. Key-based is generally the preferred method.\nFor details about creating an API key or bearer token, refer to [Authentication](https://www.elastic.co/guide/en/cloud-enterprise/current/ece-restful-api-authentication.html).\n\n## Documentation source and versions\n\nThis documentation applies to Elastic Cloud Enterprise version 3.8.\nIt is derived from https://api.elastic-cloud.com/api/v1/api-docs/swagger.json.\nIt is provided under license [Attribution-NonCommercial-NoDerivatives 4.0 International](https://creativecommons.org/licenses/by-nc-nd/4.0/).\n"},"host":"{{hostname}}","basePath":"/api/v1","schemes":["https"],"security":[{"basicAuth":[]},{"apiKey":[]}],"paths":{"/account":{"get":{"tags":["Accounts"],"summary":"Fetch current account information","description":"Fetch current account information.","operationId":"get-current-account","produces":["application/json"],"parameters":[],"responses":{"200":{"description":"Account fetched successfully","schema":{"$ref":"#/definitions/AccountResponse"}},"404":{"description":"Account not found. (code: `accounts.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["accounts.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Accounts"}},"put":{"tags":["Accounts"],"summary":"Updates the current account","description":"Updates the current account.","operationId":"update-current-account","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"the current account","required":true,"schema":{"$ref":"#/definitions/AccountUpdateRequest"}}],"responses":{"200":{"description":"Account updated successfully","schema":{"$ref":"#/definitions/AccountResponse"}},"404":{"description":"Account not found. (code: `accounts.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["accounts.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Accounts"}},"patch":{"tags":["Accounts"],"summary":"Updates the current account","description":"Updates the current account.","operationId":"patch-current-account","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"All changes in the specified object are applied to the current account according to the JSON Merge Patch processing rules. Omitting existing fields causes the same values to be reapplied. Specifying a `null` value reverts the field to the default value, or removes the field when no default value exists.","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"Account updated successfully","schema":{"$ref":"#/definitions/AccountResponse"}},"404":{"description":"Account not found. (code: `accounts.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["accounts.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Accounts"}}},"/billing/costs/{organization_id}":{"get":{"tags":["BillingCostsAnalysis"],"summary":"Get costs overview for the organization. Currently unavailable in self-hosted ECE.","description":"EXPERIMENTAL (it may change in future versions): Retrieves an overview of the costs by organization ID.","operationId":"get-costs-overview","produces":["application/json"],"parameters":[{"name":"organization_id","in":"path","description":"Identifier for the organization","required":true,"type":"string"},{"name":"from","in":"query","description":"A datetime for the beginning of the desired range for which to fetch costs. Defaults to start of current month.","required":false,"type":"string"},{"name":"to","in":"query","description":"A datetime for the end of the desired range for which to fetch costs. Defaults to the current date.","required":false,"type":"string"}],"responses":{"200":{"description":"Top-level cost overview for the organization","schema":{"$ref":"#/definitions/CostsOverview"}},"400":{"description":"The specified date range is invalid. (code: `costs.invalid_date_range`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["costs.invalid_date_range"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"403":{"description":"The current user does not have access to the requested organization. (code: `organization.invalid_access`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["organization.invalid_access"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"Organization not found. (code: `organization.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["organization.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"An error occurred when fetching an overview of the costs for the organization. (code: `billing_service.failed_request`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["billing_service.failed_request"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Billing Costs Analysis"},"deprecated":true}},"/billing/costs/{organization_id}/charts":{"get":{"tags":["BillingCostsAnalysis"],"summary":"Get charts for the organization. Currently unavailable in self-hosted ECE.","description":"EXPERIMENTAL (it may change in future versions): Retrieves the usage charts for the organization.","operationId":"get-costs-charts","produces":["application/json"],"parameters":[{"name":"organization_id","in":"path","description":"Identifier for the organization","required":true,"type":"string"},{"name":"from","in":"query","description":"A datetime for the beginning of the desired range for which to fetch costs. Defaults to start of current month.","required":false,"type":"string"},{"name":"to","in":"query","description":"A datetime for the end of the desired range for which to fetch costs. Defaults to the current date.","required":false,"type":"string"},{"name":"bucketing_strategy","in":"query","description":"The desired bucketing strategy for the charts. Defaults to `daily`.","required":false,"type":"string","default":"daily","enum":["daily","monthly"]}],"responses":{"200":{"description":"The usage charts of an organization.","schema":{"$ref":"#/definitions/ChartItems"}},"400":{"description":"The specified date range is invalid. (code: `costs.invalid_date_range`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["costs.invalid_date_range"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"403":{"description":"The current user does not have access to the requested organization. (code: `organization.invalid_access`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["organization.invalid_access"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"Organization not found. (code: `organization.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["organization.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"429":{"description":"Too many requests. (code: `billing_service.rate_limited`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["billing_service.rate_limited"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"Error fetching the itemized costs for the organization. (code: `billing_service.failed_request`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["billing_service.failed_request"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Billing Costs Analysis"},"deprecated":true}},"/billing/costs/{organization_id}/deployments":{"get":{"tags":["BillingCostsAnalysis"],"summary":"Get deployments costs for the organization. Currently unavailable in self-hosted ECE.","description":"EXPERIMENTAL (it may change in future versions): Retrieves the costs associated with all deployments for the organization.","operationId":"get-costs-deployments","produces":["application/json"],"parameters":[{"name":"organization_id","in":"path","description":"Identifier for the organization","required":true,"type":"string"},{"name":"from","in":"query","description":"A datetime for the beginning of the desired range for which to fetch activity. Defaults to start of current month.","required":false,"type":"string"},{"name":"to","in":"query","description":"A datetime for the end of the desired range for which to fetch activity. Defaults to the current date.","required":false,"type":"string"},{"name":"Accept","in":"header","description":"Accept header containing the content preference.","required":false,"type":"string"}],"responses":{"200":{"description":"The costs associated to a set of products","schema":{"$ref":"#/definitions/DeploymentsCosts"}},"400":{"description":"Invalid date range specified. (code: `costs.invalid_date_range`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["costs.invalid_date_range"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"403":{"description":"The current user does not have access to the requested organization. (code: `organization.invalid_access`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["organization.invalid_access"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"Organization not found. (code: `organization.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["organization.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"An error occurred when fetching the costs associated with all deployments for the organization. (code: `billing_service.failed_request`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["billing_service.failed_request"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Billing Costs Analysis"},"deprecated":true}},"/billing/costs/{organization_id}/deployments/{deployment_id}/charts":{"get":{"tags":["BillingCostsAnalysis"],"summary":"Get charts by deployment. Currently unavailable in self-hosted ECE.","description":"EXPERIMENTAL (it may change in future versions): Retrieves the usage charts for the given  deployment.","operationId":"get-costs-charts-by-deployment","produces":["application/json"],"parameters":[{"name":"organization_id","in":"path","description":"Identifier for the organization","required":true,"type":"string"},{"name":"deployment_id","in":"path","description":"Id of a Deployment","required":true,"type":"string"},{"name":"from","in":"query","description":"A datetime for the beginning of the desired range for which to fetch costs. Defaults to start of current month.","required":false,"type":"string"},{"name":"to","in":"query","description":"A datetime for the end of the desired range for which to fetch costs. Defaults to the current date.","required":false,"type":"string"},{"name":"bucketing_strategy","in":"query","description":"The desired bucketing strategy for the charts. Defaults to `daily`.","required":false,"type":"string","default":"daily","enum":["daily","monthly"]}],"responses":{"200":{"description":"The usage charts of a deployment.","schema":{"$ref":"#/definitions/ChartItems"}},"400":{"description":"The specified date range is invalid. (code: `costs.invalid_date_range`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["costs.invalid_date_range"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"403":{"description":"The current user does not have access to the requested organization. (code: `organization.invalid_access`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["organization.invalid_access"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"Organization not found. (code: `organization.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["organization.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"429":{"description":"Too many requests. (code: `billing_service.rate_limited`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["billing_service.rate_limited"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"Error fetching the itemized costs for the organization. (code: `billing_service.failed_request`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["billing_service.failed_request"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Billing Costs Analysis"},"deprecated":true}},"/billing/costs/{organization_id}/deployments/{deployment_id}/items":{"get":{"tags":["BillingCostsAnalysis"],"summary":"Get itemized costs by deployments. Currently unavailable in self-hosted ECE.","description":"EXPERIMENTAL (it may change in future versions): Retrieves the itemized costs for the given deployment.","operationId":"get-costs-items-by-deployment","produces":["application/json"],"parameters":[{"name":"organization_id","in":"path","description":"Identifier for the organization","required":true,"type":"string"},{"name":"deployment_id","in":"path","description":"Id of a Deployment","required":true,"type":"string"},{"name":"from","in":"query","description":"A datetime for the beginning of the desired range for which to fetch costs. Defaults to start of current month.","required":false,"type":"string"},{"name":"to","in":"query","description":"A datetime for the end of the desired range for which to fetch costs. Defaults to the current date.","required":false,"type":"string"},{"name":"Accept","in":"header","description":"Determines the response body format. Can be either application/json or text/csv.","required":false,"type":"string"}],"responses":{"200":{"description":"The costs associated to a set items billed for a single deployment.","schema":{"$ref":"#/definitions/ItemsCosts"}},"400":{"description":"The specified date range is invalid. (code: `costs.invalid_date_range`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["costs.invalid_date_range"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"403":{"description":"The current user does not have access to the requested organization. (code: `organization.invalid_access`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["organization.invalid_access"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"* The organization was not found. (code: `organization.not_found`)\n* The Elasticsearch cluster was not found. (code: `billing_service.es_cluster_id_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["organization.not_found","billing_service.es_cluster_id_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"An error occurred when fetching the itemized costs for the given deployment of the organization. (code: `billing_service.failed_request`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["billing_service.failed_request"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Billing Costs Analysis"},"deprecated":true}},"/billing/costs/{organization_id}/items":{"get":{"tags":["BillingCostsAnalysis"],"summary":"Get itemized costs for the organization. Currently unavailable in self-hosted ECE.","description":"EXPERIMENTAL (it may change in future versions): Retrieves the itemized costs for the organization.","operationId":"get-costs-items","produces":["application/json"],"parameters":[{"name":"organization_id","in":"path","description":"Identifier for the organization","required":true,"type":"string"},{"name":"from","in":"query","description":"A datetime for the beginning of the desired range for which to fetch costs. Defaults to start of current month.","required":false,"type":"string"},{"name":"to","in":"query","description":"A datetime for the end of the desired range for which to fetch costs. Defaults to the current date.","required":false,"type":"string"}],"responses":{"200":{"description":"The costs associated to a set of items","schema":{"$ref":"#/definitions/ItemsCosts"}},"400":{"description":"The specified date range is invalid. (code: `costs.invalid_date_range`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["costs.invalid_date_range"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"403":{"description":"The current user does not have access to the requested organization. (code: `organization.invalid_access`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["organization.invalid_access"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"Organization not found. (code: `organization.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["organization.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"Error fetching the itemized costs for the organization. (code: `billing_service.failed_request`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["billing_service.failed_request"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Billing Costs Analysis"},"deprecated":true}},"/comments/{resource_type}/{resource_id}":{"get":{"tags":["Comments"],"summary":"List Comments","description":"Retrieves all the comments for a given Resource, in reverse modified time order.","operationId":"list-comment","produces":["application/json"],"parameters":[{"name":"resource_type","in":"path","description":"The kind of Resource that a Comment belongs to. Should be one of [elasticsearch, kibana, apm, appsearch, enterprise_search, integrations_server, allocator, constructor, runner, proxy].","required":true,"type":"string"},{"name":"resource_id","in":"path","description":"Id of the Resource that a Comment belongs to.","required":true,"type":"string"}],"responses":{"200":{"description":"The Comments","schema":{"$ref":"#/definitions/CommentsWithMetas"}}},"x-doc":{"tag":"Comments"}},"post":{"tags":["Comments"],"summary":"Create a Comment","description":"Creates a comment for the given Resource.","operationId":"create-comment","consumes":["application/json"],"produces":["application/json"],"parameters":[{"name":"resource_type","in":"path","description":"The kind of Resource that a Comment belongs to. Should be one of [elasticsearch, kibana, apm, appsearch, enterprise_search, integrations_server, allocator, constructor, runner, proxy].","required":true,"type":"string"},{"name":"resource_id","in":"path","description":"Id of the Resource that a Comment belongs to.","required":true,"type":"string"},{"in":"body","name":"body","description":"Data for comment creation","required":true,"schema":{"$ref":"#/definitions/CommentCreateRequest"}}],"responses":{"201":{"description":"The Comment that was just created.","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/Comment"}},"401":{"description":"Your current session does not have a user id associated with it. (code: `comments.no_user_id`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["comments.no_user_id"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"No Resource of the given type and id exist. (code: `comments.resource_does_not_exist`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["comments.resource_does_not_exist"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"409":{"description":"A Comment already exists with the generated id. Please try again. (code: `comments.id_already_exists`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["comments.id_already_exists"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Comments"}}},"/comments/{resource_type}/{resource_id}/{comment_id}":{"get":{"tags":["Comments"],"summary":"Get Comment","description":"Retrieves a Comment.","operationId":"get-comment","produces":["application/json"],"parameters":[{"name":"resource_type","in":"path","description":"The kind of Resource that a Comment belongs to. Should be one of [elasticsearch, kibana, apm, appsearch, enterprise_search, integrations_server, allocator, constructor, runner, proxy].","required":true,"type":"string"},{"name":"resource_id","in":"path","description":"Id of the Resource that a Comment belongs to.","required":true,"type":"string"},{"name":"comment_id","in":"path","description":"Id of a Comment","required":true,"type":"string"}],"responses":{"200":{"description":"The Comment","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/Comment"}},"404":{"description":"The Comment you want does not exist. (code: `comments.comment_does_not_exist`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["comments.comment_does_not_exist"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Comments"}},"put":{"tags":["Comments"],"summary":"Update Comment","description":"Updates a Comment.","operationId":"update-comment","consumes":["application/json"],"produces":["application/json"],"parameters":[{"name":"resource_type","in":"path","description":"The kind of Resource that a Comment belongs to. Should be one of [elasticsearch, kibana, apm, appsearch, enterprise_search, integrations_server, allocator, constructor, runner, proxy].","required":true,"type":"string"},{"name":"resource_id","in":"path","description":"Id of the Resource that a Comment belongs to.","required":true,"type":"string"},{"name":"comment_id","in":"path","description":"Id of a Comment","required":true,"type":"string"},{"name":"version","in":"query","description":"If specified then checks for conflicts against the version stored in the persistent store (returned in 'x-cloud-resource-version' of the GET request)","required":false,"type":"string"},{"in":"body","name":"body","description":"The Comment update data.","required":true,"schema":{"$ref":"#/definitions/CommentUpdateRequest"}}],"responses":{"200":{"description":"Comment updated successfully.","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/Comment"}},"401":{"description":"* The Comment does not belong to you. (code: `comments.unauthorised`)\n* Your current session does not have a user id associated with it. (code: `comments.no_user_id`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["comments.unauthorised","comments.no_user_id"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The Comment you want does not exist. (code: `comments.comment_does_not_exist`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["comments.comment_does_not_exist"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"409":{"description":"The version you sent does not match the persisted version. (code: `comments.version_conflict`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["comments.version_conflict"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Comments"}},"delete":{"tags":["Comments"],"summary":"Delete Comment","description":"Deletes a Comment.","operationId":"delete-comment","produces":["application/json"],"parameters":[{"name":"resource_type","in":"path","description":"The kind of Resource that a Comment belongs to. Should be one of [elasticsearch, kibana, apm, appsearch, enterprise_search, integrations_server, allocator, constructor, runner, proxy].","required":true,"type":"string"},{"name":"resource_id","in":"path","description":"Id of the Resource that a Comment belongs to.","required":true,"type":"string"},{"name":"comment_id","in":"path","description":"Id of a Comment","required":true,"type":"string"},{"name":"version","in":"query","description":"If specified then checks for conflicts against the version stored in the persistent store (returned in 'x-cloud-resource-version' of the GET request)","required":false,"type":"string"}],"responses":{"200":{"description":"Comment deleted successfully.","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/EmptyResponse"}},"401":{"description":"* The Comment does not belong to you. (code: `comments.unauthorised`)\n* Your current session does not have a user id associated with it. (code: `comments.no_user_id`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["comments.unauthorised","comments.no_user_id"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The Comment you want does not exist. (code: `comments.comment_does_not_exist`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["comments.comment_does_not_exist"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"409":{"description":"The version you sent does not match the persisted version. (code: `comments.version_conflict`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["comments.version_conflict"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Comments"}}},"/deployments":{"get":{"tags":["Deployments"],"summary":"List Deployments","description":"List Deployments.","operationId":"list-deployments","produces":["application/json"],"parameters":[],"responses":{"200":{"description":"The list of deployments that belong to the authenticated user.","schema":{"$ref":"#/definitions/DeploymentsListResponse"}},"401":{"description":"You are not authorized to perform this action.","schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - CRUD"}},"post":{"tags":["Deployments"],"summary":"Create Deployment","description":"Creates a Deployment.","operationId":"create-deployment","consumes":["application/json"],"produces":["application/json"],"parameters":[{"name":"request_id","in":"query","description":"An optional idempotency token - if two create requests share the same request_id token (min size 32 characters, max 128) then only one deployment will be created, the second request will return the info of that deployment (in the same format described below, but with blanks for auth-related fields)","required":false,"type":"string"},{"name":"validate_only","in":"query","description":"If true, will just validate the Deployment definition but will not perform the creation","required":false,"type":"boolean","default":false},{"name":"template_id","in":"query","description":"An optional template id - if present, the referenced template will be used to fill in the resources field of the deployment creation request. If any resources are present in the request together with the template, the ones coming in the request will prevail and no merging with the template will be performed.","required":false,"type":"string"},{"in":"body","name":"body","description":"The deployment definition","required":true,"schema":{"$ref":"#/definitions/DeploymentCreateRequest"}}],"responses":{"200":{"description":"The request was valid (used when validate_only is true).","schema":{"$ref":"#/definitions/DeploymentCreateResponse"}},"201":{"description":"The request was valid and a new deployment was created","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/DeploymentCreateResponse"}},"202":{"description":"The request was valid and deployment creation had already been started.","schema":{"$ref":"#/definitions/DeploymentCreateResponse"}},"400":{"description":"The deployment request had errors.","schema":{"$ref":"#/definitions/BasicFailedReply"}},"401":{"description":"You are not authorized to perform this action.","schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - CRUD"}}},"/deployments/_resync":{"post":{"tags":["Deployments"],"summary":"Resynchronize Deployments","description":"Resynchronizes the search index for all the deployments.","operationId":"resync-deployments","produces":["application/json"],"parameters":[{"name":"skip_matching_version","in":"query","description":"When true, skips the document indexing when the version matches the in-memory copy.","required":false,"type":"boolean","default":true}],"responses":{"200":{"description":"The deployments resync operation executed successfully.","schema":{"$ref":"#/definitions/IndexSynchronizationResults"}},"500":{"description":"The deployments resync operation failed. (code: `deployments.resync_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.resync_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - resync"}}},"/deployments/_search":{"post":{"tags":["Deployments"],"summary":"Search Deployments","description":"Retrieves the information for all of the deployments that match the specified query.","operationId":"search-deployments","consumes":["application/json"],"produces":["application/json"],"parameters":[{"name":"minimal_metadata","in":"query","description":"Comma separated list of attributes to include in response for deployments found. Useful for reducing response size when retrieving many deployments. Use of this parameter moves the result to the minimal_metadata section of the response.","required":false,"type":"string"},{"in":"body","name":"body","description":"(Optional) The search query to run. When not specified, all of the deployments are matched.","required":false,"schema":{"$ref":"#/definitions/SearchRequest"}}],"responses":{"200":{"description":"The list of deployments that match the specified query and belong to the authenticated user.","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/DeploymentsSearchResponse"}}},"x-doc":{"tag":"Deployment - Commands"}}},"/deployments/eligible-remote-clusters":{"post":{"tags":["Deployments"],"summary":"Get eligible remote clusters","description":"Returns the list of deployments which contain eligible remote clusters for a specific version.","operationId":"search-eligible-remote-clusters","consumes":["application/json"],"produces":["application/json"],"parameters":[{"name":"version","in":"query","description":"The version of the Elasticsearch cluster cluster that will potentially be configured to have remote clusters.","required":true,"type":"string"},{"in":"body","name":"body","description":"(Optional) The search query to run against all deployments containing eligible remote clusters. When not specified, all the eligible deployments are matched.","required":false,"schema":{"$ref":"#/definitions/SearchRequest"}}],"responses":{"200":{"description":"List of deployments which contains eligible remote clusters for a specific version","schema":{"$ref":"#/definitions/DeploymentsSearchResponse"}},"400":{"description":"The provided version is invalid. (code: `stackpack.invalid_version`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["stackpack.invalid_version"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - Remote Clusters"}}},"/deployments/extensions":{"get":{"tags":["Extensions"],"summary":"List Extensions","description":"Retrieves all of the available extensions.","operationId":"list-extensions","produces":["application/json"],"parameters":[],"responses":{"200":{"description":"The extensions that are available","schema":{"$ref":"#/definitions/Extensions"}}},"x-doc":{"tag":"Deployments - Extensions"}},"post":{"tags":["Extensions"],"summary":"Create an extension","description":"Creates the extension.\n The extensions API supports two types of usage patterns.\n A). Specify a `download_url`, http or https URL,  where the extension is currently hosted. This will result in extension being copied to elastic repository.\n B). Create only the extension metadata using the `POST` endpoint and then use `PUT` to upload the extension file. Leave the `download_url` unspecified in this case.\n","operationId":"create-extension","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"the data that creates the extension","required":true,"schema":{"$ref":"#/definitions/CreateExtensionRequest"}}],"responses":{"201":{"description":"The extension that was just created.","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/Extension"}},"400":{"description":"Could not download the extension from the specified URL. (code: `extensions.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"Your current session does not have a user id associated with it. (code: `extensions.no_user_id`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.no_user_id"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"409":{"description":"An extension already exists with the generated id. Please try again. (code: `extensions.id_already_exists`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.id_already_exists"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Extensions"}}},"/deployments/extensions/{extension_id}":{"get":{"tags":["Extensions"],"summary":"Get Extension","description":"Retrieves an extension.","operationId":"get-extension","produces":["application/json"],"parameters":[{"name":"extension_id","in":"path","description":"Id of an extension","required":true,"type":"string"},{"name":"include_deployments","in":"query","description":"Include deployments referencing this extension. Up to only 10000 deployments will be included.","required":false,"type":"boolean","default":false}],"responses":{"200":{"description":"The Extension","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/Extension"}},"404":{"description":"The extension requested does not exist. (code: `extensions.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Extensions"}},"post":{"tags":["Extensions"],"summary":"Update Extension","description":"Updates an extension.","operationId":"update-extension","consumes":["application/json"],"produces":["application/json"],"parameters":[{"name":"extension_id","in":"path","description":"Id of an extension","required":true,"type":"string"},{"in":"body","name":"body","description":"The extension update data.","required":true,"schema":{"$ref":"#/definitions/UpdateExtensionRequest"}}],"responses":{"200":{"description":"Extension updated successfully.","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/Extension"}},"400":{"description":"Could not download the extension from the specified URL. (code: `extensions.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"401":{"description":"* The extension does not belong to you. (code: `extensions.unauthorised`)\n* Your current session does not have a user id associated with it. (code: `extensions.no_user_id`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.unauthorised","extensions.no_user_id"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The extension you want does not exist. (code: `extensions.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"409":{"description":"The version you sent does not match the persisted version. (code: `extensions.version_conflict`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.version_conflict"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Extensions"}},"put":{"tags":["Extensions"],"summary":"Uploads the Extension","description":"Uploads archive for an extension.","operationId":"upload-extension","consumes":["multipart/form-data"],"produces":["application/json"],"parameters":[{"name":"extension_id","in":"path","description":"Id of an extension","required":true,"type":"string"},{"name":"file","in":"formData","description":"Zip file that contains the extension","required":true,"type":"file"}],"responses":{"200":{"description":"Archive uploaded successfully.","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/Extension"}},"400":{"description":"Could not accept the extensions file. (code: `extensions.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"401":{"description":"* The extension does not belong to you. (code: `extensions.unauthorised`)\n* Your current session does not have a user id associated with it. (code: `extensions.no_user_id`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.unauthorised","extensions.no_user_id"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The extension you want does not exist. (code: `extensions.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Extensions"}},"delete":{"tags":["Extensions"],"summary":"Delete Extension","description":"Deletes a Extension.","operationId":"delete-extension","produces":["application/json"],"parameters":[{"name":"extension_id","in":"path","description":"Id of an extension","required":true,"type":"string"}],"responses":{"200":{"description":"Extension deleted successfully.","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/EmptyResponse"}},"401":{"description":"* The extension does not belong to you. (code: `extensions.unauthorised`)\n* Your current session does not have a user id associated with it. (code: `extensions.no_user_id`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.unauthorised","extensions.no_user_id"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The extension requested does not exist. (code: `extensions.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"409":{"description":"The version you sent does not match the persisted version. (code: `extensions.version_conflict`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["extensions.version_conflict"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Extensions"}}},"/deployments/templates":{"get":{"tags":["DeploymentTemplates"],"summary":"Get deployment templates","description":"Retrieves all deployment templates.","operationId":"get-deployment-templates-v2","produces":["application/json"],"parameters":[{"name":"metadata","in":"query","description":"An optional key/value pair in the form of (key:value) that will act as a filter and exclude any templates that do not have a matching metadata item associated.","required":false,"type":"string"},{"name":"show_instance_configurations","in":"query","description":"If true, will return details for each instance configuration referenced by the template.","required":false,"type":"boolean","default":true},{"name":"show_max_zones","in":"query","description":"If true, will populate the max_zones field in the instance configurations. Only relevant if show_instance_configurations=true.","required":false,"type":"boolean","default":false},{"name":"stack_version","in":"query","description":"If present, it will cause the returned deployment templates to be adapted to return only the elements allowed in that version.","required":false,"type":"string"},{"name":"hide_deprecated","in":"query","description":"If true, templates flagged as deprecated will NOT be returned.","required":false,"type":"boolean","default":false},{"name":"show_hidden","in":"query","description":"If true, templates flagged as hidden will be returned.","required":false,"type":"boolean","default":false},{"name":"region","in":"query","description":"Region of the deployment templates","required":true,"type":"string"}],"responses":{"200":{"description":"The deployment templates were returned successfully.","schema":{"type":"array","items":{"$ref":"#/definitions/DeploymentTemplateInfoV2"}}},"400":{"description":"The requested region was not found. (code: `templates.region_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.region_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"401":{"description":"The user is not authorized to access requested region. (code: `templates.region_not_allowed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.region_not_allowed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Templates"}},"post":{"tags":["DeploymentTemplates"],"summary":"Create deployment template","description":"Creates a deployment template.","operationId":"create-deployment-template-v2","consumes":["application/json"],"produces":["application/json"],"parameters":[{"name":"validate_only","in":"query","description":"If true, the deployment template definition will be validated but the template will not be created.","required":false,"type":"boolean","default":false},{"name":"region","in":"query","description":"Region of the deployment template","required":true,"type":"string"},{"in":"body","name":"body","description":"The deployment template definition.","required":true,"schema":{"$ref":"#/definitions/DeploymentTemplateRequestBody"}}],"responses":{"200":{"description":"The request was valid (used when validate_only is true).","schema":{"$ref":"#/definitions/IdResponse"}},"201":{"description":"The deployment definition was valid and the template has been created.","schema":{"$ref":"#/definitions/IdResponse"}},"400":{"description":"The requested region is not supported. (code: `templates.region_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.region_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"401":{"description":"The user is not authorized to access requested region. (code: `templates.region_not_allowed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.region_not_allowed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Templates"}}},"/deployments/templates/{template_id}":{"get":{"tags":["DeploymentTemplates"],"summary":"Get deployment template","description":"Retrieves a deployment template by id.","operationId":"get-deployment-template-v2","produces":["application/json"],"parameters":[{"name":"template_id","in":"path","description":"The identifier for the deployment template.","required":true,"type":"string"},{"name":"show_instance_configurations","in":"query","description":"If true, will return details for each instance configuration referenced by the template.","required":false,"type":"boolean","default":true},{"name":"show_max_zones","in":"query","description":"If true, will populate the max_zones field in the instance configurations. Only relevant if show_instance_configurations=true.","required":false,"type":"boolean","default":false},{"name":"stack_version","in":"query","description":"If present, it will cause the returned deployment template to be adapted to return only the elements allowed in that version.","required":false,"type":"string"},{"name":"region","in":"query","description":"Region of the deployment template","required":true,"type":"string"}],"responses":{"200":{"description":"The deployment template was found and returned successfully.","schema":{"$ref":"#/definitions/DeploymentTemplateInfoV2"}},"400":{"description":"The requested region is not supported. (code: `templates.region_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.region_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"401":{"description":"The user is not authorized to access requested region. (code: `templates.region_not_allowed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.region_not_allowed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The deployment template specified by {template_id} cannot be found. (code: `templates.template_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.template_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Templates"}},"put":{"tags":["DeploymentTemplates"],"summary":"Set deployment template","description":"Creates or updates a deployment template.","operationId":"set-deployment-template-v2","consumes":["application/json"],"produces":["application/json"],"parameters":[{"name":"template_id","in":"path","description":"The identifier for the deployment template.","required":true,"type":"string"},{"name":"version","in":"query","description":"If specified, checks for conflicts against the version of the template (returned in 'x-cloud-resource-version' of the GET request)","required":false,"type":"string"},{"name":"create_only","in":"query","description":"If true, will fail if the deployment template already exists at the given id","required":false,"type":"boolean","default":false},{"name":"validate_only","in":"query","description":"If true, the deployment template definition will be validated but the template will not be updated.","required":false,"type":"boolean","default":false},{"name":"region","in":"query","description":"Region of the deployment template","required":true,"type":"string"},{"in":"body","name":"body","description":"The deployment template definition.","required":true,"schema":{"$ref":"#/definitions/DeploymentTemplateRequestBody"}}],"responses":{"200":{"description":"The deployment definition was valid and the template has been updated.","schema":{"$ref":"#/definitions/IdResponse"}},"201":{"description":"The deployment definition was valid and the template was created.","schema":{"$ref":"#/definitions/IdResponse"}},"400":{"description":"The requested region is not supported. (code: `templates.region_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.region_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"401":{"description":"The user is not authorized to access requested region. (code: `templates.region_not_allowed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.region_not_allowed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The deployment template specified by {template_id} cannot be found. (code: `templates.template_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.template_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"409":{"description":"The version supplied in the request conflicted with the version found on the server. (code: `templates.version_conflict`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.version_conflict"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Templates"}},"delete":{"tags":["DeploymentTemplates"],"summary":"Delete deployment template","description":"Deletes a deployment template by id.","operationId":"delete-deployment-template-v2","produces":["application/json"],"parameters":[{"name":"template_id","in":"path","description":"The identifier for the deployment template.","required":true,"type":"string"},{"name":"region","in":"query","description":"Region of the deployment template","required":true,"type":"string"}],"responses":{"200":{"description":"The deployment template was successfully deleted.","schema":{"$ref":"#/definitions/EmptyResponse"}},"400":{"description":"The requested region is not supported. (code: `templates.region_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.region_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"401":{"description":"The user is not authorized to access requested region. (code: `templates.region_not_allowed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.region_not_allowed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The deployment template specified by {template_id} cannot be found. (code: `templates.template_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["templates.template_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Templates"}}},"/deployments/traffic-filter/associations/{association_type}/{associated_entity_id}/rulesets":{"get":{"tags":["DeploymentsTrafficFilter"],"summary":"Get associated rulesets","description":"Retrieves the rulesets associated with a deployment.","operationId":"get-traffic-filter-deployment-ruleset-associations","produces":["application/json"],"parameters":[{"name":"association_type","in":"path","description":"Association type","required":true,"type":"string"},{"name":"associated_entity_id","in":"path","description":"Associated entity ID","required":true,"type":"string"}],"responses":{"200":{"description":"Rulesets in the deployment were successfully returned","schema":{"$ref":"#/definitions/TrafficFilterSettings"}},"400":{"description":"Invalid association type. (code: `traffic_filter.invalid_association_type`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.invalid_association_type"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"Error fetching traffic filter rulesets. (code: `traffic_filter.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Traffic Filter - Associations"}}},"/deployments/traffic-filter/link-ids":{"get":{"tags":["DeploymentsTrafficFilter"],"summary":"List traffic filter claimed link id","description":"List all of the traffic filter claimed link id.","operationId":"get-traffic-filter-claimed-link-ids","produces":["application/json"],"parameters":[{"name":"region","in":"query","description":"If provided limits the claimed id to that region only.","required":false,"type":"string"},{"name":"organization_id","in":"query","description":"Retrieves a list of resources that are associated to the specified organization ID. It only takes effect if the user is an admin.","required":false,"type":"string"}],"responses":{"200":{"description":"The collection of traffic filter claimed link id","schema":{"$ref":"#/definitions/TrafficFilterClaimedLinkIds"}},"500":{"description":"Error fetching traffic filter claimed link ids. (code: `traffic_filter_claimed_link_id.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter_claimed_link_id.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Traffic Filter Claimed Link Id"}}},"/deployments/traffic-filter/link-ids/_claim":{"post":{"tags":["DeploymentsTrafficFilter"],"summary":"Claim a link id","description":"Claim the ownership of a link id.","operationId":"claim-traffic-filter-link-id","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"The specification for traffic filter claimed link id.","required":true,"schema":{"$ref":"#/definitions/TrafficFilterClaimedLinkIdRequest"}}],"responses":{"201":{"description":"The ruleset definition is valid and the creation has started.","schema":{"$ref":"#/definitions/TrafficFilterClaimedLinkIdInfo"}},"500":{"description":"Error creating the traffic filter ruleset. (code: `traffic_filter_claimed_link_id.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter_claimed_link_id.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Traffic Filter Claimed Link Id"}}},"/deployments/traffic-filter/link-ids/_unclaim":{"post":{"tags":["DeploymentsTrafficFilter"],"summary":"Unclaims a link id","description":"Unclaims the ownership of a link id.","operationId":"unclaim-traffic-filter-link-id","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"The specification for traffic filter claimed link id.","required":true,"schema":{"$ref":"#/definitions/TrafficFilterClaimedLinkIdRequest"}}],"responses":{"200":{"description":"The claimed link id was successfully deleted.","schema":{"$ref":"#/definitions/EmptyResponse"}},"400":{"description":"Error validating the request. (code: `traffic_filter_claimed_link_id.invalid_input`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter_claimed_link_id.invalid_input"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"Error deleting the traffic filter claimed link id. (code: `traffic_filter_claimed_link_id.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter_claimed_link_id.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Traffic Filter Claimed Link Id"}}},"/deployments/traffic-filter/rulesets":{"get":{"tags":["DeploymentsTrafficFilter"],"summary":"List traffic filter rulesets","description":"List all of the traffic filter rulesets.","operationId":"get-traffic-filter-rulesets","produces":["application/json"],"parameters":[{"name":"include_associations","in":"query","description":"Retrieves a list of resources that are associated to the specified ruleset.","required":false,"type":"boolean","default":false},{"name":"region","in":"query","description":"If provided limits the rulesets to that region only.","required":false,"type":"string"},{"name":"organization_id","in":"query","description":"Retrieves a list of resources that are associated to the specified organization ID. It only takes effect if the user is an admin.","required":false,"type":"string"}],"responses":{"200":{"description":"The collection of traffic filter routes","schema":{"$ref":"#/definitions/TrafficFilterRulesets"}},"500":{"description":"Error fetching traffic filter rulesets. (code: `traffic_filter.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Traffic Filter - CRUD"}},"post":{"tags":["DeploymentsTrafficFilter"],"summary":"Create a ruleset","description":"Creates a ruleset that consists of a set of rules.","operationId":"create-traffic-filter-ruleset","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"The specification for traffic filter ruleset.","required":true,"schema":{"$ref":"#/definitions/TrafficFilterRulesetRequest"}}],"responses":{"201":{"description":"The ruleset definition is valid and the creation has started.","schema":{"$ref":"#/definitions/TrafficFilterRulesetResponse"}},"500":{"description":"Error creating the traffic filter ruleset. (code: `traffic_filter.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Traffic Filter - CRUD"}}},"/deployments/traffic-filter/rulesets/{ruleset_id}":{"get":{"tags":["DeploymentsTrafficFilter"],"summary":"Retrieves the ruleset by ID.","description":"Retrieves a list of resources that are associated to the specified ruleset.","operationId":"get-traffic-filter-ruleset","produces":["application/json"],"parameters":[{"name":"ruleset_id","in":"path","description":"The mandatory ruleset ID.","required":true,"type":"string"},{"name":"include_associations","in":"query","description":"Retrieves a list of resources that are associated to the specified ruleset.","required":false,"type":"boolean","default":false}],"responses":{"200":{"description":"The container for a set of traffic filter rules.","schema":{"$ref":"#/definitions/TrafficFilterRulesetInfo"}},"404":{"description":"The traffic filter ruleset specified by {ruleset_id} cannot be found. (code: `traffic_filter.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"Error reading the traffic filter ruleset. (code: `traffic_filter.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Traffic Filter - CRUD"}},"put":{"tags":["DeploymentsTrafficFilter"],"summary":"Updates a ruleset","description":"Updates the ruleset with the definition.","operationId":"update-traffic-filter-ruleset","consumes":["application/json"],"produces":["application/json"],"parameters":[{"name":"ruleset_id","in":"path","description":"The mandatory ruleset ID.","required":true,"type":"string"},{"in":"body","name":"body","description":"The specification for traffic filter ruleset.","required":true,"schema":{"$ref":"#/definitions/TrafficFilterRulesetRequest"}}],"responses":{"200":{"description":"The ruleset definition was valid and the update has started.","schema":{"$ref":"#/definitions/TrafficFilterRulesetResponse"}},"404":{"description":"The traffic filter ruleset specified by {ruleset_id} cannot be found. (code: `traffic_filter.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"Error reading the traffic filter ruleset. (code: `traffic_filter.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Traffic Filter - CRUD"}},"delete":{"tags":["DeploymentsTrafficFilter"],"summary":"Delete a ruleset","description":"Deletes the ruleset by ID.","operationId":"delete-traffic-filter-ruleset","produces":["application/json"],"parameters":[{"name":"ruleset_id","in":"path","description":"The mandatory ruleset ID.","required":true,"type":"string"},{"name":"ignore_associations","in":"query","description":"When true, ignores the associations and deletes the ruleset. When false, recognizes the associations, which prevents the deletion of the rule set.","required":false,"type":"boolean","default":false}],"responses":{"200":{"description":"The traffic filter ruleset was successfully deleted.","schema":{"$ref":"#/definitions/EmptyResponse"}},"404":{"description":"The traffic filter ruleset specified by {ruleset_id} cannot be found. (code: `traffic_filter.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"Error deleting the traffic filter ruleset. (code: `traffic_filter.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Traffic Filter - CRUD"}}},"/deployments/traffic-filter/rulesets/{ruleset_id}/associations":{"get":{"tags":["DeploymentsTrafficFilter"],"summary":"Get associated deployments","description":"Retrieves a list of deployments that are associated to the specified ruleset.","operationId":"get-traffic-filter-ruleset-deployment-associations","produces":["application/json"],"parameters":[{"name":"ruleset_id","in":"path","description":"The mandatory ruleset ID.","required":true,"type":"string"}],"responses":{"200":{"description":"Associations referred by traffic filter rulesets were successfully returned","schema":{"$ref":"#/definitions/RulesetAssociations"}},"500":{"description":"Error fetching deployments. (code: `traffic_filter.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Traffic Filter - Associations"}},"post":{"tags":["DeploymentsTrafficFilter"],"summary":"Create ruleset association","description":"Applies the ruleset to the specified deployment.","operationId":"create-traffic-filter-ruleset-association","consumes":["application/json"],"produces":["application/json"],"parameters":[{"name":"ruleset_id","in":"path","description":"The mandatory ruleset ID.","required":true,"type":"string"},{"in":"body","name":"body","description":"Mandatory ruleset association description","required":true,"schema":{"$ref":"#/definitions/FilterAssociation"}}],"responses":{"200":{"description":"Create association request was valid and the association already exists","schema":{"$ref":"#/definitions/EmptyResponse"}},"201":{"description":"Create association request was valid and the association has been created","schema":{"$ref":"#/definitions/EmptyResponse"}},"404":{"description":"The traffic filter ruleset specified by {ruleset_id} cannot be found. (code: `traffic_filter.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"Creation failed. (code: `traffic_filter.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Traffic Filter - Associations"}}},"/deployments/traffic-filter/rulesets/{ruleset_id}/associations/{association_type}/{associated_entity_id}":{"delete":{"tags":["DeploymentsTrafficFilter"],"summary":"Delete ruleset association","description":"Deletes the traffic rules in the ruleset from the deployment.","operationId":"delete-traffic-filter-ruleset-association","produces":["application/json"],"parameters":[{"name":"ruleset_id","in":"path","description":"The mandatory ruleset ID.","required":true,"type":"string"},{"name":"association_type","in":"path","description":"Association type","required":true,"type":"string"},{"name":"associated_entity_id","in":"path","description":"Associated entity ID","required":true,"type":"string"}],"responses":{"200":{"description":"Delete association request was valid and the association has been deleted","schema":{"$ref":"#/definitions/EmptyResponse"}},"404":{"description":"The traffic filter ruleset association cannot be found. (code: `traffic_filter.not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"Deletion failed. (code: `traffic_filter.request_execution_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["traffic_filter.request_execution_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployments - Traffic Filter - Associations"}}},"/deployments/{deployment_id}":{"get":{"tags":["Deployments"],"summary":"Get Deployment","description":"Retrieves information about a Deployment.","operationId":"get-deployment","produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment","required":true,"type":"string"},{"name":"show_security","in":"query","description":"Whether to include the Elasticsearch 2.x security information in the response - can be large per cluster and also include credentials","required":false,"type":"boolean","default":false},{"name":"show_metadata","in":"query","description":"Whether to include the full cluster metadata in the response - can be large per cluster and also include credentials","required":false,"type":"boolean","default":false},{"name":"show_plans","in":"query","description":"Whether to include the full current and pending plan information in the response - can be large per cluster","required":false,"type":"boolean","default":true},{"name":"show_plan_logs","in":"query","description":"Whether to include with the current and pending plan information the attempt log - can be very large per cluster","required":false,"type":"boolean","default":false},{"name":"show_plan_history","in":"query","description":"Whether to include the plan history with the current and pending plan information. The results can be very large per cluster.\n By default, if a given resource kind (e.g. Elasticsearch, Kibana, etc.) has more than 100 plans\n (which should be very rare, most likely caused by a bug) only 100 plans are returned for the given resource type:\n The first 10 plans, and the last 90 plans for that resource type.\n If ALL of the plans are desired, pass the `force_all_plan_history` parameter with a value of `true`.\n","required":false,"type":"boolean","default":false},{"name":"show_plan_defaults","in":"query","description":"If showing plans, whether to show values that are left at their default value (less readable but more informative)","required":false,"type":"boolean","default":false},{"name":"convert_legacy_plans","in":"query","description":"If showing plans, whether to leave pre-2.0.0 plans in their legacy format (the default), or whether to update them to 2.0.x+ format (if 'true')","required":false,"type":"boolean","default":false},{"name":"show_system_alerts","in":"query","description":"Number of system alerts (such as forced restarts due to memory limits) to be included in the response - can be large per cluster. Negative numbers or 0 will not return field.","required":false,"type":"integer","default":0},{"name":"show_settings","in":"query","description":"Whether to show cluster settings in the response.","required":false,"type":"boolean","default":false},{"name":"show_instance_metrics","in":"query","description":"Whether to show resources instance metrics in the response.","required":false,"type":"boolean","default":true},{"name":"show_instance_configurations","in":"query","description":"If true, will return details for each instance configuration referenced by the deployment.","required":false,"type":"boolean","default":true},{"name":"enrich_with_template","in":"query","description":"If showing plans, whether to enrich the plan by including the missing elements from the deployment template it is based on","required":false,"type":"boolean","default":true},{"name":"force_all_plan_history","in":"query","description":"Force show the entire plan history no matter how long.\n As noted in the `show_plan_history` parameter description, by default, a maximum of 100 plans are shown per resource. \n If `true`, this parameter overrides the default, and ALL plans are returned.\n Use with care as the plan history can be VERY large. Consider pairing with `show_plan_logs=false`.\n ","required":false,"type":"boolean","default":false},{"name":"clear_transient","in":"query","description":"If set (defaults to false) then removes the transient section from all child resources, making it safe to reapply via an update","required":false,"type":"boolean","default":false}],"responses":{"200":{"description":"The Deployment info response","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/DeploymentGetResponse"}},"401":{"description":"You are not authorized to perform this action.","schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - CRUD"}},"put":{"tags":["Deployments"],"summary":"Update Deployment","description":"Updates a Deployment.","operationId":"update-deployment","consumes":["application/json"],"produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment","required":true,"type":"string"},{"name":"hide_pruned_orphans","in":"query","description":"Whether or not to hide orphaned resources that were shut down (relevant if prune on the request is true)","required":false,"type":"boolean","default":false},{"name":"skip_snapshot","in":"query","description":"Whether or not to skip snapshots before shutting down orphaned resources (relevant if prune on the request is true)","required":false,"type":"boolean","default":false},{"name":"validate_only","in":"query","description":"If true, will just validate the Deployment definition but will not perform the update","required":false,"type":"boolean","default":false},{"name":"version","in":"query","description":"If specified then checks for conflicts against the version stored in the persistent store (returned in 'x-cloud-resource-version' of the GET request)","required":false,"type":"string"},{"in":"body","name":"body","description":"The deployment definition","required":true,"schema":{"$ref":"#/definitions/DeploymentUpdateRequest"}}],"responses":{"200":{"description":"The request was valid and the deployment was updated.","headers":{"x-cloud-resource-version":{"type":"string","description":"The resource version, which is used to avoid update conflicts with concurrent operations"},"x-cloud-resource-created":{"type":"string","description":"The date-time when the resource was created (ISO format relative to UTC)"},"x-cloud-resource-last-modified":{"type":"string","description":"The date-time when the resource was last modified (ISO format relative to UTC)"}},"schema":{"$ref":"#/definitions/DeploymentUpdateResponse"}},"400":{"description":"The deployment request had errors.","schema":{"$ref":"#/definitions/BasicFailedReply"}},"401":{"description":"You are not authorized to perform this action.","schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - CRUD"}},"delete":{"tags":["Deployments"],"summary":"Delete Deployment","description":"Deletes a Deployment and all its resources.","operationId":"delete-deployment","produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment","required":true,"type":"string"}],"responses":{"200":{"description":"The request was valid and the deployment was deleted.","schema":{"$ref":"#/definitions/DeploymentDeleteResponse"}},"400":{"description":"The Deployment resources have not been shutdown yet.","schema":{"$ref":"#/definitions/BasicFailedReply"}},"401":{"description":"You are not authorized to perform this action.","schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - CRUD"}}},"/deployments/{deployment_id}/_restore":{"post":{"tags":["Deployments"],"summary":"Restores a shutdown Deployment","description":"Restores all resources in a Deployment.","operationId":"restore-deployment","produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment","required":true,"type":"string"},{"name":"restore_snapshot","in":"query","description":"Whether or not to restore a snapshot for those resources that allow it.","required":false,"type":"boolean","default":false}],"responses":{"200":{"description":"The request was valid and the resources of the deployment were restored.","schema":{"$ref":"#/definitions/DeploymentRestoreResponse"}},"400":{"description":"There are Elasticsearch resources in the deployment which are not shut down.","schema":{"$ref":"#/definitions/BasicFailedReply"}},"401":{"description":"You are not authorized to perform this action.","schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - CRUD"}}},"/deployments/{deployment_id}/_resync":{"post":{"tags":["Deployments"],"summary":"Resynchronize Deployment","description":"Immediately resynchronizes the search index for the selected deployment.","operationId":"resync-deployment","produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment","required":true,"type":"string"}],"responses":{"200":{"description":"The deployment resync operation executed successfully.","schema":{"$ref":"#/definitions/IndexSynchronizationResults"}},"500":{"description":"The deployment resync operation failed for deployment {deployment_id}. (code: `deployments.resync_failed`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.resync_failed"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - resync"}}},"/deployments/{deployment_id}/_shutdown":{"post":{"tags":["Deployments"],"summary":"Shuts down Deployment","description":"Shuts down all resources in a Deployment.","operationId":"shutdown-deployment","produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment","required":true,"type":"string"},{"name":"hide","in":"query","description":"Whether or not to hide the deployment and its resources.Only applicable for Platform administrators.","required":false,"type":"boolean"},{"name":"skip_snapshot","in":"query","description":"Whether or not to skip snapshots before shutting down the resources","required":false,"type":"boolean","default":false}],"responses":{"200":{"description":"The request was valid and the resources of the deployment were shutdown.","schema":{"$ref":"#/definitions/DeploymentShutdownResponse"}},"400":{"description":"Parameter is restricted and can only be set by a Platform administrator. (code: `deployments.restricted_parameter`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.restricted_parameter"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"401":{"description":"You are not authorized to perform this action.","schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - CRUD"}}},"/deployments/{deployment_id}/apm/{ref_id}":{"get":{"tags":["Deployments"],"summary":"Get Deployment APM Resource Info","description":"Get info about an APM Resource belonging to a given Deployment.","operationId":"get-deployment-apm-resource-info","produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment","required":true,"type":"string"},{"name":"ref_id","in":"path","description":"User-specified RefId for the Resource (or '_main' if there is only one).","required":true,"type":"string"},{"name":"show_metadata","in":"query","description":"Whether to include the full cluster metadata in the response - can be large per cluster and also include credentials.","required":false,"type":"boolean","default":false},{"name":"show_plans","in":"query","description":"Whether to include the full current and pending plan information in the response - can be large per cluster.","required":false,"type":"boolean","default":true},{"name":"show_plan_logs","in":"query","description":"Whether to include with the current and pending plan information the attempt log - can be very large per cluster.","required":false,"type":"boolean","default":false},{"name":"show_plan_history","in":"query","description":"Whether to include with the current and pending plan information the plan history- can be very large per cluster.","required":false,"type":"boolean","default":false},{"name":"show_plan_defaults","in":"query","description":"If showing plans, whether to show values that are left at their default value (less readable but more informative).","required":false,"type":"boolean","default":false},{"name":"show_settings","in":"query","description":"Whether to show cluster settings in the response.","required":false,"type":"boolean","default":false},{"name":"clear_transient","in":"query","description":"If set (defaults to false) then removes the transient section from all child resources, making it safe to reapply via an update","required":false,"type":"boolean","default":false}],"responses":{"200":{"description":"Standard response.","schema":{"$ref":"#/definitions/ApmResourceInfo"}},"404":{"description":"The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_resource_no_longer_exists"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - Info"}}},"/deployments/{deployment_id}/apm/{ref_id}/_reset-token":{"post":{"tags":["Deployments"],"summary":"Reset the secret token for an APM resource.","description":"Reset the token of an APM resource.","operationId":"deployment-apm-reset-secret-token","produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment.","required":true,"type":"string"},{"name":"ref_id","in":"path","description":"User-specified RefId for the Resource (or '_main' if there is only one).","required":true,"type":"string"}],"responses":{"202":{"description":"Response containing the new secret token, plan to apply it starts","schema":{"$ref":"#/definitions/ApmCrudResponse"}},"400":{"description":"Reset token is not supported when APM is managed by Elastic Agent. (code: `clusters.cluster_plan_state_error`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["clusters.cluster_plan_state_error"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"404":{"description":"* The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)\n* The Resource specified by {ref_id} cannot be found. (code: `deployments.deployment_resource_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_not_found","deployments.deployment_resource_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_resource_no_longer_exists"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"APM routes"}}},"/deployments/{deployment_id}/appsearch/{ref_id}":{"get":{"tags":["Deployments"],"summary":"Get Deployment App Search Resource Info","description":"Get info about an App Search Resource belonging to a given Deployment.","operationId":"get-deployment-appsearch-resource-info","produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment","required":true,"type":"string"},{"name":"ref_id","in":"path","description":"User-specified RefId for the Resource (or '_main' if there is only one).","required":true,"type":"string"},{"name":"show_metadata","in":"query","description":"Whether to include the full cluster metadata in the response - can be large per cluster and also include credentials.","required":false,"type":"boolean","default":false},{"name":"show_plans","in":"query","description":"Whether to include the full current and pending plan information in the response - can be large per cluster.","required":false,"type":"boolean","default":true},{"name":"show_plan_logs","in":"query","description":"Whether to include with the current and pending plan information the attempt log - can be very large per cluster.","required":false,"type":"boolean","default":false},{"name":"show_plan_history","in":"query","description":"Whether to include with the current and pending plan information the plan history- can be very large per cluster.","required":false,"type":"boolean","default":false},{"name":"show_plan_defaults","in":"query","description":"If showing plans, whether to show values that are left at their default value (less readable but more informative).","required":false,"type":"boolean","default":false},{"name":"show_settings","in":"query","description":"Whether to show cluster settings in the response.","required":false,"type":"boolean","default":false},{"name":"clear_transient","in":"query","description":"If set (defaults to false) then removes the transient section from all child resources, making it safe to reapply via an update","required":false,"type":"boolean","default":false}],"responses":{"200":{"description":"Standard response.","schema":{"$ref":"#/definitions/AppSearchResourceInfo"}},"404":{"description":"The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_resource_no_longer_exists"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - Info"}}},"/deployments/{deployment_id}/appsearch/{ref_id}/read_only_mode":{"get":{"tags":["Deployments"],"summary":"Set AppSearch read-only status","description":"Enable/Disable read-only mode on the given App Search resource.","operationId":"get-appsearch-read-only-mode","produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment.","required":true,"type":"string"},{"name":"ref_id","in":"path","description":"User-specified RefId for the Resource (or '_main' if there is only one).","required":true,"type":"string"}],"responses":{"200":{"description":"Standard response","schema":{"$ref":"#/definitions/ReadOnlyResponse"}},"404":{"description":"The Resource specified by ref_id cannot be found. (code: `deployments.deployment_resource_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_resource_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_resource_no_longer_exists"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"App Search - Read-only"}},"put":{"tags":["Deployments"],"summary":"Set AppSearch read-only status","description":"Enable/Disable read-only mode on the given App Search resource.","operationId":"set-appsearch-read-only-mode","consumes":["application/json"],"produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment.","required":true,"type":"string"},{"name":"ref_id","in":"path","description":"User-specified RefId for the Resource (or '_main' if there is only one).","required":true,"type":"string"},{"in":"body","name":"body","description":"read-only request body","required":true,"schema":{"$ref":"#/definitions/ReadOnlyRequest"}}],"responses":{"200":{"description":"Standard response","schema":{"$ref":"#/definitions/ReadOnlyResponse"}},"404":{"description":"The Resource specified by ref_id cannot be found. (code: `deployments.deployment_resource_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_resource_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}},"500":{"description":"We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_resource_no_longer_exists"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"App Search - Read-only"}}},"/deployments/{deployment_id}/certificate-authority":{"get":{"tags":["Deployments"],"summary":"Get certificate authority","description":"Returns the certificate authority used to sign the certificates of this deployment.","operationId":"get-deployment-certificate-authority","produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment.","required":true,"type":"string"}],"responses":{"200":{"description":"The certificate authority used to sign the certificates of this deployment","schema":{"$ref":"#/definitions/CertificateAuthority"}},"404":{"description":"* The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)\n* The Elasticsearch Resource cannot be found. (code: `deployments.deployment_resource_not_found`)","headers":{"x-cloud-error-codes":{"type":"string","description":"The error codes associated with the response","enum":["deployments.deployment_not_found","deployments.deployment_resource_not_found"]}},"schema":{"$ref":"#/definitions/BasicFailedReply"}}},"x-doc":{"tag":"Deployment - Trust"}}},"/deployments/{deployment_id}/elasticsearch/{ref_id}":{"get":{"tags":["Deployments"],"summary":"Get Deployment Elasticsearch Resource Info","description":"Get info about an Elasticsearch Resource belonging to a given Deployment.","operationId":"get-deployment-es-resource-info","produces":["application/json"],"parameters":[{"name":"deployment_id","in":"path","description":"Identifier for the Deployment","required":true,"type":"string"},{"name":"ref_id","in":"path","description":"User-specified RefId for the Resource (or '_main' if there is only one).","required":true,"type":"string"},{"name":"show_security","in":"query","description":"Whether to include the Elasticsearch 2.x security information in the response - can be large per cluster and also include credentials.","required":false,"type":"boolean","default":false},{"name":"show_metadata","in":"query","description":"Whether to include the full cluster metadata in the response - can be large per cluster and also include credentials.","required":false,"type":"boolean","default":false},{"name":"show_plans","in":"query","description":"Whether to include the full current and pending plan information in the response - can be large per cluster.","required":false,"type":"boolean","default":true},{"name":"show_plan_logs","in":"query","description":"Whether to include with the current and pending plan information the attempt log - can be very large per cluster.","required":false,"type":"boolean","default":false},{"name":"show_plan_history","in":"query","description":"Whether to include with the current and pending plan information the plan history- can be very large per cluster.","required":false,"type":"boolean","default":false},{"name":"show_plan_defaults","in":"query","description":"If showing plans, whether to show values that are left at their default value (less readable but more informative).","required":false,"type":"boolean","default":false},{"name":"convert_legacy_plans","in":"query","description":"If showing plans, whether to leave pre-2.0.0 plans in their legacy format (the default), or whether to update them to 2.0
[...]
